#include "RHYME.h"
#include <stdio.h>
#include <stdlib.h>

RP newRhymePair(string word1, string word2) {
	RP result = (RP)malloc(sizeof(struct RhymePair));
	result->word1 = word1;
	result->word2 = word2;
	return result;
}

void deleteRhymePair(RP this) {
	free(this);
}

RPList nil() {
	RPList result = (RPList)malloc(sizeof(struct RhymePairList));
	result->tail = NULL;
	return result;
}

RPList newRhymePairList(RP head, RPList tail) {
	RPList result = (RPList)malloc(sizeof(struct RhymePairList));
	result->head = head;
	result->tail = tail;
	return result;
}

void deleteRhymePairList(RPList this) {
	if (!(this->tail == NULL)) deleteRhymePairList(this->tail);
	free(this);
}

RPList fromWordList(WordList* ws) {
	void appendRhymePairList(RPList *old_element, RPList new_element) {
		RPList ptr = *old_element;

		if (!(ptr == NULL)) {
			while (!(ptr->tail->tail == NULL)) ptr = ptr->tail;
			ptr->tail = new_element;
		} else { *old_element = new_element; };
	}

	RPList pairlist = NULL;
	for (int i = 0; i < ws->length; i++) {
		for (int j = i; j < ws->length; j++) {
			if (doRhyme(ws->words[i], ws->words[j])) {
				if (!(strEq(ws->words[i], ws->words[j]))) {
					RP pair = newRhymePair(ws->words[i], ws->words[j]);
					RPList pairlist2 = newRhymePairList(pair, nil());
					appendRhymePairList(&pairlist, pairlist2);
				}
			}
		}
	}

	return pairlist;
}

RP spoonerism(RPList this, RP rhymeWords) {
	RPList ptr = this;

	if (!(ptr == NULL)) {
		while (!(ptr->tail->tail == NULL)) {
			if (startsWithSameConsonants(ptr->head->word1, rhymeWords->word1)) {
				if (startsWithSameConsonants(ptr->head->word2, rhymeWords->word2)) {
					if (!(strEq(ptr->head->word1, rhymeWords->word1))) {
					if (!(strEq(ptr->head->word1, rhymeWords->word2))) {
					if (!(strEq(ptr->head->word2, rhymeWords->word1))) {
					if (!(strEq(ptr->head->word2, rhymeWords->word2))) {
						return newRhymePair(ptr->head->word1, ptr->head->word2);
					} } } }
				}
			}
			ptr = ptr->tail;
		}
        }

	return NULL;
}
