#include "WORDS.h"
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>

string readFile(string fileName){
  struct stat fileStat;
    
  if (stat(fileName, &fileStat) == 0){
    nat fileSize = fileStat.st_size;

    string content = (string)malloc((fileSize+1)*sizeof(char));
    content[fileSize]='\0';

    FILE* file = fopen(fileName,"r");

    if (file){
      for  (int i=0;!feof(file);i++){
	char c = fgetc(file);
	if (c!=EOF) content[i]=c;
      }
      return content;
    }else return NULL;
  }
  return NULL;
}

boolean isVowel(char c){
  switch(c){
    case 'a':
    case 'A':
    case 'e':
    case 'E':
    case 'i':
    case 'I':
    case 'o':
    case 'O':
    case 'u':
    case 'U': return true;
    default : return false;
  }
}

boolean isUmlaut(char c){
  switch(c){
    case '':
    case '':
    case '':
    case '':
    case '':
    case '': return true;
    default : return false;
  }
}

boolean isAlpha(char c){
  return  (c >= 'A' && c<= 'Z') 
       || (c >= 'a' && c<= 'z') 
       || isUmlaut(c)
       || c=='';
}

void stringMap(char f(char),string str){
  while (*str != '\0'){
    *str = f(*str);
    str=str+1;
  }
}

void wordListMap(WordList* this,void f(string)){
  for (int i=0;i<this->length;i++){
    f(this->words[i]);
  }
}

char toLower(char c){
  if ((c>='A')&&(c<='Z')) return c-('A'-'a');
  else if (c=='') return '';
  else if (c=='') return '';
  else if (c=='') return '';
  else return c;
}

void stringToLower(string str){
  stringMap(toLower,str);
}

void wordListToLower(WordList* this){
  wordListMap(this,stringToLower);
}

nat countWords(string str){
  nat result=0;
  boolean lastWasNoCharacter = true;
  for (int i=0;str[i]!='\0';i++){
    char current = str[i];
    if (!lastWasNoCharacter && !isAlpha(current)){
      result=result+1;
      lastWasNoCharacter = true;
    }else if (isAlpha(current)){
      lastWasNoCharacter=false;
    }
  }
  return result;
}

WordList* newWordList(nat length,string* words){
  WordList* this=(WordList*)malloc(sizeof(WordList));
  this->length = length;
  this->words = words;
  return this;
}

void deleteWordList(WordList* this){
  for (int i=0;i<this->length;i++){
    free(this->words[i]);
  }
  free(this->words);
  free(this);
}

string nextWord(int* i,string str){
  nat j = *i;
  while (!isAlpha(str[j])){
    j=j+1;
  }
  nat startIndex = j;
  while (isAlpha(str[j])){
    j=j+1;
  }
  nat endIndex = j;
  *i=j;
  nat length = endIndex-startIndex;
  string result = (string)malloc(sizeof(char)*(length+1));
  result[length]='\0';
  for (int k = 0;startIndex+k < endIndex;k++){
    result[k] = str[startIndex+k];
  }
  return result;
}

WordList* words(string str){
  nat numberOfWords=countWords(str);
  string* words = (string*)malloc(numberOfWords*sizeof(string));
  int offset=0;
  for (int i=0;i<numberOfWords;i++){
    words[i]=nextWord(&offset,str);
  }

  return newWordList(numberOfWords,words); 
}

int strLength(string this){
  int i=0;
  for (;this[i]!='\0';i++) {}
  return i;
}

string strCopy(string this){
  nat l = strLength(this);
  string result = (string)malloc(sizeof(char)*(l+1));
  for (int i = 0; i <= l ; i=i+1){
    result[i]=this[i];
  }
  return result;
}

boolean strEq(string this, string that){
  if (strLength(this)==strLength(that)){
    for(int i=0;this[i]!='\0';i++){
      if (this[i]!=that[i]) return false;
    }
  } else return false;
  return true;
}

boolean contains(string* words,nat length,string w){
  for (int i=0;i<length;i++){
    if (strEq(words[i],w)) return true;
  }
  return false;
}

void nub(WordList* this){
  string* words=(string*)malloc(this->length*sizeof(string));
  int length=0;
  for (int i=0;i<this->length;i++){
    if (!contains(words,length,this->words[i])){
      words[length] = this->words[i];
      length = length+1;
    }
  }
  string* words2=(string*)malloc(length*sizeof(string));
  for (int i=0;i<length;i++){
    words2[i] = strCopy(words[i]);
  }
  for (int i=0;i<this->length;i++){
    free(this->words[i]);
  }
  free(this->words);
  free(words);
  this->words=words2;
  this->length=length;
}

boolean doRhyme(string this, string that) {
  int i = 0, j = 0;
  for (; (isVowel(this[i])||isUmlaut(this[i])) != true; i++) {}
  for (; (isVowel(that[j])||isUmlaut(that[j])) != true; j++) {}

  if ((i == strLength(this)) || (j == strLength(that))) return false;
  else if ((strLength(this)-i) != (strLength(that)-j)) return false;
  else {
    for (; this[i] != '\0'; i++, j++) {
      if (this[i] != that[j]) return false;
    }
  }

  return true;
}

boolean startsWithSameConsonants(string s1, string s2) {
  int i = 0, j = 0;
  for (; (isVowel(s1[i])||isUmlaut(s1[i])) != true; i++) {}
  for (; (isVowel(s2[j])||isUmlaut(s2[j])) != true; j++) {}

  if ((i == strLength(s1)) || (j == strLength(s2))) return false;
  else if ((i == 0) || (j == 0)) return false;
  else if (i != j) return false;
  else {
    for (i = 0; i < j; i++) {
      if (s1[i] != s2[i]) return false;
    }
  }

  return true;
}
